#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;
int m, group;

pair<int, int> readAns(InStream& stream) {
    int max_can_erase = stream.readInt(0, m, "max_can_erase");
    int number_of_ways = stream.readInt(-1, MOD - 1, "number_of_ways");
    return {max_can_erase, number_of_ways};
}

int points_full[] = {0, 11, 9, 12, 13, 20, 21, 14};
int points_part[] = {0, 7,  5,  8, 8,  12, 13, 8};

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    inf.readInt();
    m = inf.readInt();
    group = inf.readInt();

    auto pans = readAns(ouf);
    auto jans = readAns(ans);
    
    if (group == 0) {
        if (pans == jans) {
            quitf(_ok, "both answers are correct");
        } else if (pans.first == jans.first) {
            quitf(_ok, "first answer is correct");
        } else {
            quitf(_wa, "Wrong answer");
        }
    }

    if (pans == jans) {
        quitp(points_full[group], "both answers are correct");
    } else if (pans.first == jans.first) {
        quitp(points_part[group], "first answer is correct");
    } else {
        quitf(_wa, "both answers are incorrect");
    }
}
