// incorrect solution for SCC testcases:
// check if cycle, otherwise take edge iff
// removing it breaks strong connectivity

#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> gr;

void remove_degree_2() {
    int n = gr.size();
    vector<vector<int>> gr_t(n);
    for (int i = 0; i < n; ++i) {
        for (int to : gr[i]) {
            gr_t[to].push_back(i);
        }
    }
    vector<bool> removed(n);
    for (int i = 0; i < n; ++i) {
        if (gr[i].size() == 1 && gr_t[i].size() == 1) {
            int from = gr_t[i][0], to = gr[i][0];
            gr[i].clear();
            gr_t[i].clear();
            *find(gr[from].begin(), gr[from].end(), i) = to;
            *find(gr_t[to].begin(), gr_t[to].end(), i) = from;
            removed[i] = true;
        }
    }
}

vector<int> st;
vector<int> t;
int timer = 0;
vector<int> comp_color;
int banned_from = -1, banned_to = -1;

void dfs(int v) {
    int tin = timer++;
    t[v] = tin;
    st.push_back(v);
    for (auto to : gr[v]) {
        if (v == banned_from && to == banned_to) continue;
        if (t[to] == -1) {
            dfs(to);
            t[v] = min(t[v], t[to]);
        } else if (comp_color[to] == -1) {
            t[v] = min(t[v], t[to]);
        }
    }
    if (tin == t[v]) {
        int cc = v;
        for (int i = st.size() - 1; st[i] != v; --i) {
            cc = min(cc, st[i]);
        }
        while (st.back() != v) {
            comp_color[st.back()] = cc;
            st.pop_back();
        }
        comp_color[v] = cc;
        st.pop_back();
    }
}

void scc_colors() {
    st.clear();
    timer = 0;
    t.assign(gr.size(), -1);
    comp_color.assign(gr.size(), -1);
    for (int i = 0; i < gr.size(); ++i) {
        if (t[i] == -1) {
            dfs(i);
        }
    }
}

int main() {
    int n, m, type;
    cin >> n >> m >> type;
    gr.resize(n);
    vector<pair<int, int>> edges(m);
    for (auto& [u, v] : edges) {
        cin >> u >> v;
        u--, v--;
        gr[u].push_back(v);
    }

    scc_colors();

    if (n == m && *min_element(comp_color.begin(), comp_color.end()) == *max_element(comp_color.begin(), comp_color.end())) {
        cout << n - 1 << '\n';
        return 0;
    }

    remove_degree_2();

    scc_colors();
    auto initial_comp_color = comp_color;

    int ans = m;

    for (int u = 0; u < n; ++u) {
        for (int v : gr[u]) {
            banned_from = u, banned_to = v;
            scc_colors();
            if (comp_color == initial_comp_color) {
                ans--;
            }
        }
    }

//    for (int i = 0; i < n; ++i) {
//        if (i == 0)
//    }

    cout << ans << '\n';
    cout << -1 << '\n';
}
